//SpracheWechseln_204d.js
// 30.07.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script dient zum Wechseln der verwendeten Sprache

// die Listen der Sprachen vorbereiten
var indLangList = new Array("[No Language]", "Bulgarian", "German: Traditional", 
"German: Reformed", "German: Swiss", "Danish", "English: UK", 
"English: Canadian", "English: USA", "English: USA Medical", "English: USA Legal", 
"Estonian", "Finnish", "French", "French: Canadian", "Greek", "Italian", 
"Catalan", "Croatian", "Latvian", "Lithuanian", "Dutch", "Norwegian: Bokmal", 
"Norwegian: Nynorsk", "Polish", "Portuguese", "Portuguese: Brazilian", "Romanian", 
"Russian", "Swedish", "Slovak", "Slovenian", "Spanish: Castilian", "Czech", 
"Turkish", "Hungarian");

var locLangList = new Array("[Keine Sprache]", "Bulgarisch", "Deutsch: Alte Rechtschr.", 
"Deutsch: Neue Rechtschr.", "Deutsch: Schweiz", "Dnisch", "Englisch: Grobritannien", 
"Englisch: Kanada", "Englisch: USA", "Englisch: USA Medizin", "Englisch: USA Recht", 
"Estnisch", "Finnisch", "Franzsisch", "Franzsisch: Kanada", "Griechisch", "Italienisch", 
"Katalanisch", "Kroatisch", "Lettisch", "Litauisch", "Niederlndisch", "Norwegisch: Bokml", 
"Norwegisch: Nynorsk", "Polnisch", "Portugiesisch", "Portugiesisch: Brasilien", "Rumnisch", 
"Russisch", "Schwedisch", "Slowakisch", "Slowenisch", "Spanisch: Standard", "Tschechisch", 
"Trkisch", "Ungarisch");

// die Datei lesen, in welcher die zuletzt angewendete Sprache gespeichert ist
var curLang = 0;
var f = new File("~/Library/Preferences/curLang.txt");
fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		curLang = (f.read())*1;
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
// Dialoge, welche eventuell im Speicher geblieben sind, lschen
var numDialogs = app.dialogs.length;
if (numDialogs > 0){
	for (var ctr=0; ctr < numDialogs; ctr++){
		app.dialogs.item(0).destroy();
	}
}

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist (wenn nicht: den Ordner-Auswahldialog zeigen)
var nDocs = app.documents.length;
if (nDocs == 0) {
	var folderObj = File (Folder.selectDialog("Den Ordner auswhlen, welcher die InDesign-Dokumente enthlt."));
	var testObj = "" + folderObj;
	if (testObj.match("null")) {
		exit();
	}
	// den Handler aufrufen, welcher die Wahl der neuen Sprache anzeigt
	var newLang = askUser();
	// eventuelle Dialoge wegen fehlender Bilder und Schriften ausschalten
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	// den Inhalt des Ordners auflisten
	var allFiles = folderObj.getFiles();
	
	// eine Schleife durch die Dateien
	for (var i=0; i<allFiles.length; i++) {
		var curName = allFiles[i].name;
		if (curName.match(".indd")) {
			try {
				// die aktuelle Datei ffnen
				app.open(File (allFiles[i]));
				changeLanguage(newLang);
				app.activeDocument.close(SaveOptions.yes);
			}
			catch (e) {
			}
		}
	}
	// die Dialoge wieder einschalten
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
}
else {
	var newLang = askUser();
	var docRef = new Array ();
	for (var i=0; i<nDocs; i++) {
		docRef.push(app.documents[i].name);
	}
	var okay = true;
	for (var i=0; i<docRef.length; i++) {
		app.activeDocument = app.documents.item(docRef[i]);
		if (nDocs>1 && i>0) {
			var okay = confirm ("Die Sprache dieses Dokuments ndern?\n\nMit Klick auf \"Yes\" besttigen.");
		}
		if (okay) {
			changeLanguage(newLang);
		}
	}
	app.activeDocument = app.documents.item(docRef[0]);
}

alert ("Fertig.");

// der Handler, welcher die Auswahl der neuen Sprache ermglicht
function askUser() {
	// einen Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Sprache wechseln", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Neue Sprache:", minWidth:80});
				staticTexts.add({staticLabel:"", minWidth:20});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var langName = dropdowns.add({stringList:locLangList, selectedIndex:curLang, minWidth:130});
				}
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:4});
			}
		}
	}
	
	// den Dialog anzeigen, die Wahl des Anwenders speichern
	if (aDialog.show() == true) {
		var langID = langName.selectedIndex;
		var newLang = (indLangList[langID]);
		aDialog.destroy();
	}
	else {
		aDialog.destroy();
		exit();
	}
	
	// die Nummer der Sprache in die Datei schreiben
	var f = new File("~/Library/Preferences/curLang.txt");
	fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(langID);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return newLang;
}

// der Handler zum Wechseln der Sprache
function changeLanguage(newLang) {
	// die Sprache der Absatzformate wechseln
	nParaStyles = app.documents[0].paragraphStyles.length;
	for (var i=0; i<nParaStyles; i++) {
		try {
			var curLang = app.documents[0].paragraphStyles[i].appliedLanguage.name;
			if (curLang != "[No Language]") {
				app.documents[0].paragraphStyles[i].appliedLanguage = newLang;
			}
		}
		catch (e) {
		}
	}
	
	// die Sprache der Zeichenformate wechseln
	nCharStyles = app.documents[0].characterStyles.length;
	for (var i=0; i<nCharStyles; i++) {
		try {
			var curLang = app.documents[0].characterStyles[i].appliedLanguage.name;
			if (curLang != "[No Language]") {
				app.documents[0].characterStyles[i].appliedLanguage = newLang;
			}
		}
		catch (e) {
		}
	}
	
	// die Sprache der Texte ndern, damit auch solche ohne Format bercksichtigt werden
	app.documents[0].stories.everyItem().appliedLanguage = newLang;
	// die Tabellen auch behandeln
	try {
		app.documents[0].stories.everyItem().tables.everyItem().cells.everyItem().texts[0].appliedLanguage = newLang;
	}
	catch (e) {
	}
}